<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package news_press_release
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function news_press_release_body_classes( $classes ) {
  global $post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

	if ( is_multi_author() ) {
		$classes[] = 'group-blog ';
	}

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( news_press_release_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
    	$classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

	return $classes;
}
add_filter( 'body_class', 'news_press_release_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function news_press_release_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'news_press_release_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function news_press_release_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'news_press_release_excerpt_more' );

if( ! function_exists( 'news_press_release_footer_credit' ) ):
/**
 * Footer Credits
*/
function news_press_release_footer_credit(){
   $news_press_release_footer_copyright = get_theme_mod( 'news_press_release_footer_copyright_setting',true );
    if ( $news_press_release_footer_copyright ){
        $news_press_release_copyright_text = get_theme_mod( 'news_press_release_footer_copyright_text' );

        $news_press_release_text  = '<div class="site-info"><div class="container"><span class="copyright">';
        if( $news_press_release_copyright_text ){
            $news_press_release_text .= wp_kses_post( $news_press_release_copyright_text ); 
        }else{
            $news_press_release_text .= esc_html__( '&copy; ', 'news-press-release' ) . date_i18n( esc_html__( 'Y', 'news-press-release' ) ); 
            $news_press_release_text .= ' <a href="' . esc_url( home_url( '/' ) ) . '">' . esc_html( get_bloginfo( 'name' ) ) . '</a>'. esc_html__( '. All Rights Reserved.', 'news-press-release' );
        }
        $news_press_release_text .= '</span>';
        $news_press_release_text .= '<span class="by"> <a href="' . esc_url( 'https://themeignite.com/products/free-news-wordpress-theme' ) .'" rel="nofollow" target="_blank">' . NEWS_PRESS_RELEASE_THEME_NAME . '</a> ' . esc_html__( 'By ', 'news-press-release' ) . '' . '<a href="' . esc_url( 'https://themeignite.com/' ) .'" rel="nofollow" target="_blank">' . esc_html__( 'Themeignite', 'news-press-release' ) . '</a>';
        $news_press_release_text .= sprintf( esc_html__( ' Powered By %s', 'news-press-release' ), '<a href="'. esc_url( __( 'https://wordpress.org/', 'news-press-release' ) ) .'" target="_blank">WordPress</a>.' );
        if ( function_exists( 'the_privacy_policy_link' ) ) {
            $news_press_release_text .= get_the_privacy_policy_link();
        }
        $news_press_release_text .= '</span></div></div>';
        echo apply_filters( 'news_press_release_footer_text', $news_press_release_text );
    }
}
add_action( 'news_press_release_footer', 'news_press_release_footer_credit' );
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'news_press_release_woocommerce_activated' ) ) {
  function news_press_release_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'news_press_release_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function news_press_release_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $aria_req = ( $req ? " aria-required='true'" : '' );
    $required = ( $req ? " required" : '' );
    $author   = ( $req ? __( 'Name*', 'news-press-release' ) : __( 'Name', 'news-press-release' ) );
    $email    = ( $req ? __( 'Email*', 'news-press-release' ) : __( 'Email', 'news-press-release' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'news-press-release' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $author ) . '" type="text" value="' . esc_attr( $commenter['comment_author'] ) . '" size="30"' . $aria_req . $required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'news-press-release' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $email ) . '" type="text" value="' . esc_attr(  $commenter['comment_author_email'] ) . '" size="30"' . $aria_req . $required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'news-press-release' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'news-press-release' ) . '" type="text" value="' . esc_attr( $commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'news_press_release_change_comment_form_default_fields' );

if( ! function_exists( 'news_press_release_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function news_press_release_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'news-press-release' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'news-press-release' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'news_press_release_change_comment_form_defaults' );

if( ! function_exists( 'news_press_release_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function news_press_release_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
	/**
	 * Triggered after the opening <body> tag.
    */
	do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'news_press_release_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function news_press_release_get_fallback_svg( $news_press_release_post_thumbnail ) {
    if( ! $news_press_release_post_thumbnail ){
        return;
    }
    
    $news_press_release_image_size = news_press_release_get_image_sizes( $news_press_release_post_thumbnail );
     
    if( $news_press_release_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $news_press_release_image_size['width'] ); ?> <?php echo esc_attr( $news_press_release_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $news_press_release_image_size['width'] ); ?>" height="<?php echo esc_attr( $news_press_release_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function news_press_release_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-ibm',
        wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=IBM+Plex+Sans:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;1,100;1,200;1,300;1,400;1,500;1,600;1,700&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'news_press_release_enqueue_google_fonts' );


if( ! function_exists( 'news_press_release_site_branding' ) ) :
/**
 * Site Branding
*/
function news_press_release_site_branding(){
    $news_press_release_logo_site_title = get_theme_mod( 'header_site_title', 0 );
    $news_press_release_tagline = get_theme_mod( 'header_tagline', false );
    $news_press_release_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding text-center" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($news_press_release_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('news_press_release_site_title_size', '30')); ?>px;">
                 <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
            </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($news_press_release_tagline) :
            $news_press_release_description = get_bloginfo('description', 'display');
            if ($news_press_release_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $news_press_release_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'news_press_release_navigation' ) ) :
/**
 * Site Navigation
*/
function news_press_release_navigation(){ ?>
    <div class="header-menu-inner">
        <nav class="main-navigation" id="site-navigation"  role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
    </div>
    <?php
}
endif;

if( ! function_exists( 'news_press_release_header_social_info' ) ) :
/**
 * Social Info
*/
function news_press_release_header_social_info(){ 
    $news_press_release_social     = get_theme_mod( 'news_press_release_social_icon_setting',true );
    ?>
    <?php if ( $news_press_release_social ){?>
        <div class="social-links">
            <?php 
              $news_press_release_social_link1 = get_theme_mod( 'news_press_release_social_link_1' );
              $news_press_release_social_link2 = get_theme_mod( 'news_press_release_social_link_2' );
              $news_press_release_social_link3 = get_theme_mod( 'news_press_release_social_link_3' );
              $news_press_release_social_link4 = get_theme_mod( 'news_press_release_social_link_4' );

              if ( ! empty( $news_press_release_social_link1 ) ) {
                echo '<a class="social1" href="' . esc_url( $news_press_release_social_link1 ) . '" target="_blank"><i class="fab fa-facebook-f"></i></a>';
              }
              if ( ! empty( $news_press_release_social_link2 ) ) {
                echo '<a class="social2" href="' . esc_url( $news_press_release_social_link2 ) . '" target="_blank"><i class="fab fa-twitter"></i></a>';
              } 
              if ( ! empty( $news_press_release_social_link3 ) ) {
                echo '<a class="social3" href="' . esc_url( $news_press_release_social_link3 ) . '" target="_blank"><i class="fab fa-instagram"></i></a>';
              }
              if ( ! empty( $news_press_release_social_link4 ) ) {
                echo '<a class="social4" href="' . esc_url( $news_press_release_social_link4 ) . '" target="_blank"><i class="fab fa-pinterest-p"></i></a>';
              }
            ?>
        </div>
    <?php } ?>
    <?php
}
endif;

if( ! function_exists( 'news_press_release_top_header_info' ) ) :
/**
 * Top Header Info
*/
function news_press_release_top_header_info(){ 
    $news_press_release_top_header_user = get_theme_mod( 'news_press_release_top_header_user' );
    $news_press_release_top_header_subscribe = get_theme_mod( 'news_press_release_top_header_subscribe' ); ?>

    <div class="header-right">
        <?php if ( ! empty( $news_press_release_top_header_user ) ) {
            echo '<a class="userlink" href="' . esc_url( $news_press_release_top_header_user ) . '" target="_blank"><i class="fas fa-user"></i></a>';
            
        }

        if ( ! empty( $news_press_release_top_header_subscribe ) ) { ?>
            <a class="subslink" href="<?php echo esc_url( $news_press_release_top_header_subscribe ); ?>" target="_blank"><i class="fas fa-envelope"></i> <?php esc_html_e('SUBSCRIBE','news-press-release'); ?></a>
       <?php }
        ?>
    </div>

<?php }

endif;

if( ! function_exists( 'news_press_release_header_info' ) ) :
/**
 * Header Info
*/
function news_press_release_header_info(){ ?>
        <div class="header_info">
            <span><i class="fas fa-calendar-alt"></i><?php echo esc_html( wp_date( 'd-m-y' ) ); ?></span>
        </div>
    <?php
}
endif;

if( ! function_exists( 'news_press_release_header' ) ) :
/**
 * Header Start
*/
function news_press_release_header(){
    $news_press_release_header_top     = get_theme_mod( 'news_press_release_header_setting',true );
    $news_press_release_header_image = get_header_image();
    $news_press_release_sticky_header = get_theme_mod('news_press_release_sticky_header' ,false);
    ?>

    <header id="masthead" style="background-image: url('<?php echo esc_url( $news_press_release_header_image ); ?>');" class="site-header" role="banner">
        
        <?php if ( $news_press_release_header_top ){?>
            <div class="top_header py-2">
                <div class="container">
                    <div class="row">
                        <div class="col-lg-4 col-md-4 align-self-center"> 
                            <?php news_press_release_header_social_info(); ?>
                        </div>
                        <div class="col-lg-4 col-md-4 align-self-center">
                            <?php news_press_release_site_branding(); ?>
                        </div>
                        <div class="col-lg-4 col-md-4 align-self-center">
                            <?php news_press_release_top_header_info(); ?>
                        </div>
                    </div>
                </div>
            </div>
        <?php } ?>

        <div id="header-box" class="header-inner " data-sticky="<?php echo $news_press_release_sticky_header; ?>">
            <div class="container">
                <div class="row">
                    <div class="col-lg-2 col-md-4 align-self-center">
                        <?php news_press_release_header_info(); ?>
                    </div>
                    <div class="col-lg-10 col-md-8 align-self-center">
                        <?php news_press_release_navigation(); ?>
                    </div>
                </div>
            </div>
        </div>
    </header>
    <?php
}
endif;
add_action( 'news_press_release_header', 'news_press_release_header', 20 );